<template>
  <b-container
    v-if="filter"
    class="large-container"
  >
    <b-row class="mt-2">
      <b-col cols="12">
        <b-alert
          v-model="showError"
          class="mb-3"
          dismissible
          variant="danger"
        >
          <h5>Error changing filter visibility</h5>
          <pre>{{ visibilityErrorMsg }}</pre>
        </b-alert>
      </b-col>
      <b-col>
        <h1>{{ filter.name }}</h1>
        <span>Created at {{ formatISODate(filter.created_at) }} (UTC)</span>
        <p class="mt-2">
          {{ filter.description }}
        </p>
      </b-col>
      <b-col
        v-if="canPerformActionsOnFilter(filter.user_id)"
        class="text-right"
        sm="2"
      >
        <confirmation-modal
          ref="visibilityConfirmationModal"
          variant="primary"
        />
        <b-form-checkbox
          v-model="public"
          :disabled="togglingVisibility"
          switch
          @change="toggleVisibility()"
        >
          Public
        </b-form-checkbox>
      </b-col>
    </b-row>
    <b-row>
      <b-col>
        <filter-versions-viewer
          :filter.sync="filter"
          class="mt-4"
        />
      </b-col>
    </b-row>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';
import { BModal } from 'bootstrap-vue';
import { FilterService } from '@/api';
import { Filter } from '@/common/types';
import ConfirmationModal from '@/components/ConfirmationModal.vue';
import FilterVersionsViewer from '@/components/Filter/VersionsViewer.vue';

export default Vue.extend({
  components: {
    ConfirmationModal,
    FilterVersionsViewer,
  },

  data() {
    return {
      filter: null as Filter | null,
      public: false,
      showError: false,
      togglingVisibility: false,
      visibilityErrorMsg: '',
    };
  },

  computed: {
    ...mapGetters(['canPerformActionsOnFilter']),
  },

  watch: {
    visibilityErrorMsg(msg: string) {
      this.showError = msg !== '';
    },
  },

  mounted() {
    this.fetchFilter();
  },

  methods: {
    async fetchFilter() {
      const { data: filter } = await FilterService.get(this.$route.params.filterId, {});
      this.filter = filter;
      this.public = filter.public;
    },
    async toggleVisibility() {
      if (!this.filter) return;

      const prevPublic = !this.public;
      const toggleFn = this.public ? FilterService.makePublic : FilterService.makePrivate;
      this.togglingVisibility = true;
      const confirm = await (this.$refs.visibilityConfirmationModal as BModal).prompt(
        `Are you sure you want to make the filter "${this.filter.name}" ${this.public ? 'public' : 'private'}?`,
        this.filter.name,
      );
      if (!confirm) {
        this.public = prevPublic;
        this.togglingVisibility = false;
        return;
      }

      try {
        const { data: filter } = await toggleFn(this.filter.id);
        this.filter = filter;
        this.visibilityErrorMsg = '';
      } catch (errors) {
        const { 0: error } = errors as Error[];
        this.visibilityErrorMsg = JSON.stringify(error, null, 2);
        this.showError = true;
        this.public = prevPublic;
      }
      this.togglingVisibility = false;
    },
  },
});
</script>

<style scoped>
h1 {
  font-size: 1.4em;
}
span {
  font-size: 0.9rem;
  color: #777777;
}
</style>
